/*
**  ComponentJS -- Component System for JavaScript <http://componentjs.com>
**  Copyright (c) 2009-2013 Ralf S. Engelschall <http://engelschall.com>
**
**  This Source Code Form is subject to the terms of the Mozilla Public
**  License, v. 2.0. If a copy of the MPL was not distributed with this
**  file, You can obtain one at http://mozilla.org/MPL/2.0/.
*/

(function(m,r,p){var c=function(){},d=function(){return c.hook("ComponentJS:lookup","pass",c.lookup.apply(m,arguments))};d.pattern={};d.symbol=function(){var a;a=void 0;var b=null;return function(c){null!==b&&(m[b]=a);"undefined"===typeof c||""===c?b=null:(b=c,a=m[b],m[b]=d);return d}}();d.ns=function(a,b){if("string"!==typeof a||""===a)throw"invalid namespace path";var c=a.split("."),f=c.length;"undefined"!==typeof b&&f--;for(var g=0,d=m;g<f;)"undefined"===typeof d[c[g]]&&(d[c[g]]={}),d=d[c[g++]];
"undefined"!==typeof b&&(d=d[c[g]]=b);return d};d.version={major:0,minor:9,micro:9,date:20130510};c.exception=function(a,b){var c;0<d.debug()&&"object"===typeof m.console&&("function"===typeof m.console.trace?m.console.trace():"undefined"!==typeof m.printStackTrace&&"function"===typeof m.console.log&&(c=m.printStackTrace(),m.console.log(c.join("\n"))));return Error("[ComponentJS]: ERROR: "+a+": "+b)};c.log=function(a){c.hook("ComponentJS:log","or",a)||("undefined"!==typeof m.console&&"undefined"!==
typeof m.console.log?m.console.log("[ComponentJS]: "+a):"undefined"!==typeof m.Titanium&&("undefined"!==typeof m.Titanium.API&&"function"===typeof m.Titanium.API.log)&&m.Titanium.API.log("[ComponentJS]: "+a))};d.debug=function(){var a=9;return function(b,e){if(0===arguments.length)return a;if(1===arguments.length)a=b;else if(b<=a){for(var f="",g=1;g<b;g++)f+="    ";c.log("DEBUG["+b+"]: "+f+e)}}}();d.nop=function(){};c.annotation=function(a,b,c){var f=null;b="__ComponentJS_"+b+"__";"undefined"!==typeof a&&
null!==a&&("undefined"!==typeof a[b]&&(f=a[b]),"undefined"!==typeof c&&(null!==c?a[b]=c:delete a[b]));return f};c.isdefined=function(a){return"undefined"!==typeof a};c.isown=function(a,b){var c=Object.hasOwnProperty.call(a,b);if("constructor"===b||"prototype"===b)c=c&&Object.propertyIsEnumerable.call(a,b),-1!==a[b].toString().indexOf("[native code]")&&(c=!1);return c};c.istypeof=function(a){var b=typeof a;"object"===b?null===a?b="null":"[object String]"===Object.prototype.toString.call(a)?b="string":
"[object Number]"===Object.prototype.toString.call(a)?b="number":"[object Boolean]"===Object.prototype.toString.call(a)?b="boolean":"[object Function]"===Object.prototype.toString.call(a)?b="function":"[object Array]"===Object.prototype.toString.call(a)?b="array":null!==c.annotation(a,"type")&&(b=c.annotation(a,"type")):"function"===b&&null!==c.annotation(a,"type")&&(b=c.annotation(a,"type"));return b};c.keysof=function(a){var b=[],c;for(c in a)a.hasOwnProperty(c)&&b.push(c);return b};c.json=function(){var a=
/[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g,b={"\b":"\\b","\t":"\\t","\n":"\\n","\f":"\\f","\r":"\\r",'"':'\\"',"\\":"\\\\"},e=function(c){a.lastIndex=0;return a.test(c)?'"'+c.replace(a,function(a){var c=b[a];return"string"===typeof c?c:"\\u"+("0000"+a.charCodeAt(0).toString(16)).slice(-4)})+'"':'"'+c+'"'},f=function(a,b){if("undefined"!==typeof b[a])return"null /* [...] */";b[a]=!0;switch(typeof a){case "null":a="null";
break;case "boolean":a=String(a);break;case "number":a=isFinite(a)?String(a):"null";break;case "string":a=e(a);break;case "function":a=null!==c.annotation(a,"type")?"<"+c.annotation(a,"type")+">":"<function>";break;case "object":var f=[];if(a)if(null!==c.annotation(a,"type"))a="<"+c.annotation(a,"type")+">";else if("[object Function]"===Object.prototype.toString.call(a))a="<function>";else if("[object Array]"===Object.prototype.toString.call(a)||a instanceof Array){for(var d=0;d<a.length;d++)f[d]=
arguments.callee(a[d],b);a=0===f.length?"[]":"["+f.join(",")+"]"}else{for(d in a)if(Object.hasOwnProperty.call(a,d)){var n=arguments.callee(a[d],b);f.push(e(d)+":"+n)}a=0===f.length?"{}":"{"+f.join(",")+"}"}else a="null";break;default:a="<unknown>"}return a};return function(a){return f(a,{})}}();c.clone=function(a,b){if("undefined"===typeof b)b=function(){return!0};else if("string"===typeof b){var e=b;b=function(a){return a.match(e)}}var f=arguments.callee,d=function(a,b){var e=function(){return a.apply(this,
arguments)};e.prototype=a.prototype;for(var d in a)c.isown(a,d)&&(b(d,a)?e[d]=f(a[d],b):e[d]=a[d]);c.annotation(e,"clone",!0);return e},h;h=void 0;if("function"===typeof a)h=d(a,b);else if("object"===typeof a)if(null===a)h=null;else if("[object String]"===Object.prototype.toString.call(a))h=""+a.valueOf();else if("[object Number]"===Object.prototype.toString.call(a))h=0+a.valueOf();else if("[object Boolean]"===Object.prototype.toString.call(a))h=!!a.valueOf();else if("[object Function]"===Object.prototype.toString.call(a))h=
d(a,b);else if("[object Date]"===Object.prototype.toString.call(a))h=new Date(a.getTime());else if("[object RegExp]"===Object.prototype.toString.call(a))h=RegExp(a.source);else if("[object Array]"===Object.prototype.toString.call(a)){d=a.length;h=Array(d);for(var k=0;k<d;k++)h.push(f(a[k],b))}else{h={};for(k in a)"constructor"!==k&&c.isown(a,k)&&(b(k,a)?h[k]=f(a[k],b):h[k]=a[k]);"function"===typeof a.constructor&&(h.constructor=a.constructor);"object"===typeof a.prototype&&(h.prototype=a.prototype)}else h=
a;return h};c.extend=function(a,b,e){if("undefined"===typeof e)e=function(){return!0};else if("string"===typeof e){var f=e;e=function(a){return a.match(f)}}for(var d in b)c.isown(b,d)&&e(d,b[d])&&(a[d]=b[d]);return a};c.mixin=function(a,b,e){if("undefined"===typeof e)e=function(){return!0};else if("string"===typeof e){var f=e;e=function(a){return a.match(f)}}for(var d in b)if(c.isown(b,d)&&e(d,b[d]))if("function"===c.istypeof(b[d])){var h=c.clone(b[d],e);c.annotation(h,"name",d);"function"===c.istypeof(a[d])&&
c.isown(a,d)&&c.annotation(h,"base",a[d]);a[d]=h}else a[d]=b[d];return a};c.concat=function(){for(var a=[],b=0;b<arguments.length;b++)for(var c=arguments[b],f=0;f<c.length;f++)a.push(c[f]);return a};c.slice=function(a,b,c){var f=[];"undefined"===typeof c&&(c=a.length);for(;b<c;b++)f.push(a[b]);return f};c.map=function(a,b){for(var c=[],f=0;f<a.length;f++)c.push(b(a[f],f));return c};c.filter=function(a,b){for(var c=[],f=0;f<a.length;f++)b(a[f],f)&&c.push(a[f]);return c};c.foreach=function(a,b){for(var c=
0;c<a.length;c++)b(a[c],c)};c.token=function(){this.text="";this.tokens=[];this.len=this.pos=0};c.token.prototype={setText:function(a){this.text=a},addToken:function(a,b,c,f,d){this.tokens.push({b1:a,b2:b,e2:c,e1:f,symbol:d});this.len++},peek:function(a){"undefined"===typeof a&&(a=0);if(a>=this.len)throw Error("parse error: not enough tokens");return this.tokens[this.pos+a].symbol},skip:function(a){"undefined"===typeof a&&(a=1);if(a>this.len)throw Error("parse error: not enough tokens available to skip: "+
this.ctx());this.pos+=a;this.len-=a},consume:function(a){if(0>=this.len)throw Error("parse error: no more tokens available to consume: "+this.ctx());if(this.tokens[this.pos].symbol!==a)throw Error('parse error: expected token symbol "'+a+'": '+this.ctx());this.pos++;this.len--},ctx:function(a){"undefined"===typeof a&&(a=78);var b=this.tokens[this.pos],c="<"+this.text.substr(b.b2,b.e2-b.b2+1)+">",c=this.text.substr(b.b1,b.b2-b.b1)+c,c=c+this.text.substr(b.e2,b.e1-b.e2);a-=c.length;if(0<a){a=Math.floor(a/
2);var f;if(0<this.pos){var d=0;for(f=this.pos-1;0<=f;f--){b=this.tokens[f];b=this.text.substr(b.b1,b.e1-b.b1+1);d+=b.length;if(d>a)break;c=b+c}0<f&&(c="[...]"+c)}if(1<this.len){d=0;for(f=this.pos+1;f<this.pos+this.len;f++){b=this.tokens[f];b=this.text.substr(b.b1,b.e1-b.b1+1);d+=b.length;if(d>a)break;c+=b}f<this.pos+this.len&&(c+="[...]")}}return c=c.replace(/\r/,"\\r").replace(/\n/,"\\n").replace(/\t/,"\\t")}};d.validate=function(a,b,e){var f;e||(f=c.validate_cache[b]);"undefined"===typeof f&&(f=
c.validate_compile(b));e||(c.validate_cache[b]=f);return c.validate_executor.exec_spec(a,f)};c.validate_cache={};c.validate_compile=function(a){a=c.validate_tokenize(a);return c.validate_parser.parse_spec(a)};c.validate_tokenize=function(a){var b=new c.token;b.setText(a);for(var e,f=0;""!==a;){e=a.match(/^(\s*)([^{}\[\]:,?*+()!|\s]+|[{}\[\]:,?*+()!|])(\s*)/);if(null===e)throw Error('parse error: cannot further canonicalize: "'+a+'"');b.addToken(f,f+e[1].length,f+e[1].length+e[2].length-1,f+e[0].length-
1,e[2]);a=a.substr(e[0].length);f+=e[0].length}return b};c.validate_parser={parse_spec:function(a){if(0>=a.len)return null;var b=a.peek();if("!"===b)a=this.parse_not(a);else if("("===b)a=this.parse_group(a);else if("{"===b)a=this.parse_hash(a);else if("["===b)a=this.parse_array(a);else if(b.match(/^(?:undefined|boolean|number|string|function|object)$/))a=this.parse_primary(a);else if(b.match(/^(?:clazz|trait|component)$/))a=this.parse_special(a);else if("any"===b)a=this.parse_any(a);else if(b.match(/^[A-Z][_a-zA-Z$0-9]*$/))a=
this.parse_class(a);else throw Error('parse error: invalid token symbol: "'+a.ctx()+'"');return a},parse_not:function(a){a.consume("!");a=this.parse_spec(a);return a={type:"not",op:a}},parse_group:function(a){a.consume("(");for(var b=this.parse_spec(a);"|"===a.peek();){a.consume("|");var c=this.parse_spec(a),b={type:"or",op1:b,op2:c}}a.consume(")");return b},parse_hash:function(a){a.consume("{");for(var b=[];"}"!==a.peek();){var c=this.parse_key(a),f=this.parse_arity(a,"?");a.consume(":");var d=this.parse_spec(a);
b.push({type:"element",key:c,arity:f,element:d});if(","===a.peek())a.skip();else break}b={type:"hash",elements:b};a.consume("}");return b},parse_array:function(a){a.consume("[");for(var b=[];"]"!==a.peek();){var c=this.parse_spec(a),f=this.parse_arity(a,"?*+");b.push({type:"element",element:c,arity:f});if(","===a.peek())a.skip();else break}b={type:"array",elements:b};a.consume("]");return b},parse_primary:function(a){var b=a.peek();if(!b.match(/^(?:undefined|boolean|number|string|function|object)$/))throw Error('parse error: invalid primary type "'+
b+'"');a.skip();return{type:"primary",name:b}},parse_special:function(a){var b=a.peek();if(!b.match(/^(?:clazz|trait|component)$/))throw Error('parse error: invalid special type "'+b+'"');a.skip();return{type:"special",name:b}},parse_any:function(a){var b=a.peek();if("any"!==b)throw Error('parse error: invalid any type "'+b+'"');a.skip();return{type:"any"}},parse_class:function(a){var b=a.peek();if(!b.match(/^[A-Z][_a-zA-Z$0-9]*$/))throw Error('parse error: invalid class type "'+b+'"');a.skip();return{type:"class",
name:b}},parse_arity:function(a,b){var c=[1,1];if(5<=a.len&&"{"===a.peek(0)&&a.peek(1).match(/^[0-9]+$/)&&","===a.peek(2)&&a.peek(3).match(/^(?:[0-9]+|oo)$/)&&"}"===a.peek(4))c=[parseInt(a.peek(1),10),"oo"===a.peek(3)?Number.MAX_VALUE:parseInt(a.peek(3),10)],a.skip(5);else if(1<=a.len&&1===a.peek().length&&0<=b.indexOf(a.peek())){switch(a.peek()){case "?":c=[0,1];break;case "*":c=[0,Number.MAX_VALUE];break;case "+":c=[1,Number.MAX_VALUE]}a.skip()}return c},parse_key:function(a){var b=a.peek();if(!b.match(/^[_a-zA-Z$][_a-zA-Z$0-9]*$/))throw Error('parse error: invalid key "'+
b+'"');a.skip();return b}};c.validate_executor={exec_spec:function(a,b){var c=!1;if(null!==b)switch(b.type){case "not":c=this.exec_not(a,b);break;case "or":c=this.exec_or(a,b);break;case "hash":c=this.exec_hash(a,b);break;case "array":c=this.exec_array(a,b);break;case "primary":c=this.exec_primary(a,b);break;case "special":c=this.exec_special(a,b);break;case "class":c=this.exec_class(a,b);break;case "any":c=!0;break;default:throw Error('validation error: invalid validation AST: node has unknown type "'+
b.type+'"');}return c},exec_not:function(a,b){return!this.exec_spec(a,b.op)},exec_or:function(a,b){return this.exec_spec(a,b.op1)||this.exec_spec(a,b.op2)},exec_hash:function(a,b){var c,f,d="object"===typeof a,h={};if(d)for(c=0;c<b.elements.length;c++)if(f=b.elements[c],h[f.key]=f.element,0<f.arity[0]&&"undefined"===typeof a[f.key]){d=!1;break}if(d)for(var k in a)if(Object.hasOwnProperty.call(a,k)&&("undefined"===typeof h[k]||!this.exec_spec(a[k],h[k]))){d=!1;break}return d},exec_array:function(a,
b){var c,f,d="object"===typeof a&&a instanceof Array;if(d){var h=0;for(c=0;c<b.elements.length;c++){f=b.elements[c];for(var k=0;k<f.arity[1]&&h<a.length&&this.exec_spec(a[h],f.element);)k++,h++;if(k<f.arity[0]){d=!1;break}}h<a.length&&(d=!1)}return d},exec_primary:function(a,b){return typeof a===b.name},exec_class:function(a,b){return"object"===typeof a&&Object.prototype.toString.call(a)==="[object "+b.name+"]"||eval("value instanceof "+b.name)},exec_special:function(a,b){var e=!1;if(typeof a===("component"===
b.name?"object":"function"))e=c.annotation(a,"type")===b.name;return e}};d.params=function(a,b,e){c.hook("ComponentJS:params:"+a+":enter","none",{args:b,spec:e});var f={},g=0,h=0,k={},l;for(l in e)c.isown(e,l)&&("undefined"!==typeof e[l].pos&&(k[e[l].pos]=l,"number"===typeof e[l].pos&&g++,"undefined"!==typeof e[l].req&&e[l].req&&h++),"undefined"!==typeof e[l].def&&(f[l]=e[l].def));var n=!1;if(1===b.length&&"object"===c.istypeof(b[0]))for(l in n=!0,b[0])c.isown(b[0],l)&&"undefined"===typeof e[l]&&
(n=!1);var q=function(a,b,e,f){if("string"===typeof f){if(!d.validate(e,f))throw c.exception(a,'value of parameter "'+b+'" not valid');}else if("object"===typeof f&&f instanceof RegExp){if(!("string"===typeof e&&e.match(f)))throw c.exception(a,'value of parameter "'+b+'" not valid (regexp)');}else if("function"===typeof f&&!f(e))throw c.exception(a,'value of parameter "'+b+'" not valid (callback)');};if(n){g=b[0];for(l in g)if(c.isown(g,l)){if("undefined"===typeof e[l])throw c.exception(a,'unknown parameter "'+
l+'"');q(a,l,g[l],e[l].valid);f[l]=g[l]}for(l in e)if(c.isown(e,l)&&"undefined"!==typeof e[l].req&&e[l].req&&"undefined"===typeof g[l])throw c.exception(a,'required parameter "'+l+'" missing');}else{if(b.length<h)throw c.exception(a,"invalid number of arguments (at least "+h+" required)");for(l=0;l<g&&l<b.length;l++)q(a,k[l],b[l],e[k[l]].valid),f[k[l]]=b[l];if(l<b.length){if("undefined"===typeof k["..."])throw c.exception(a,"too many arguments provided");for(g=[];l<b.length;l++)q(a,k["..."],b[l],
e[k["..."]].valid),g.push(b[l]);f[k["..."]]=g}}c.hook("ComponentJS:params:"+a+":leave","none",{args:b,spec:e,params:f});return f};c.base16_number=function(a,b,c){var f="";"undefined"===typeof b&&(b=0);"undefined"===typeof c&&(c=!1);for(c=c?"0123456789ABCDEF":"0123456789abcdef";0<a||0<b;)f=c.charAt(Math.floor(a%16))+f,a=Math.floor(a/16),0<b&&b--;return f};c.cid=function(){var a=[0,0,0,0];return function(){a[3]++;for(var b=0,e=3;0<=e;e--)b+=a[e],a[e]=Math.floor(b%4294967296),b=Math.floor(b/4294967296);
return c.base16_number(a[0],8,!0)+c.base16_number(a[1],8,!0)+c.base16_number(a[2],8,!0)+c.base16_number(a[3],8,!0)}}();c.proxy=function(a,b,e){"string"===c.istypeof(b)&&"object"===c.istypeof(a)&&"function"===c.istypeof(a[b])&&(b=a[b]);c.isdefined(e)||(e=!1);var f=function(){var d=function(){"object"===c.istypeof(arguments.callee.__ctx__)&&(arguments.callee.__ctx__.__this__=this);return b.apply(arguments.callee.__ctx__,arguments)};d.__ctx__=e?c.clone(c.isdefined(this.__ctx__)?this.__ctx__:a):a;e&&
(d.clone=f);d.guid=b.guid=b.guid||d.guid||c.cid();return d};return f.call({})};c.memoize=function(a){var b=function(){var b=c.json(c.slice(arguments,0)),f;"undefined"!==typeof arguments.callee.cache[b]?f=arguments.callee.cache[b]:(f=a.apply(this,arguments),arguments.callee.cache[b]=f);return f};b.cache={};return b};c.curry=function(a){var b=c.slice(arguments,1);return function(){var e=c.slice(arguments,0),e=c.concat(b,e);return a.apply(this,e)}};d.attribute=function(){var a=d.params("attribute",arguments,
{name:{pos:0,req:!0},def:{pos:1,req:!0},validate:{pos:2,def:null}});return c.proxy({value:a.def},function(b,e){var f=this.value;if(0<arguments.length){var d=!0;if(null!==a.validate)if("string"===typeof a.validate||"boolean"===typeof a.validate||"number"===typeof a.validate)d=b===a.validate;else if("object"===typeof a.validate&&a.validate instanceof RegExp)d=a.validate.test(b);else if("function"===typeof a.validate)d=a.validate(b,f,e,a.name);else throw c.exception("attribute",'validation value "'+
a.validate+'" for attribute "'+a.name+'" is of unsupported type "'+typeof a.validate+'"');if("undefined"!==typeof e&&e)return d;if(d)this.value=b,d=this.__this__,"undefined"!==typeof d&&"function"===typeof d.notify&&d.notify.call(d,"attribute:set:"+a.name,b,f,a.name);else throw c.exception("attribute",'invalid value "'+b+'" for attribute "'+a.name+'"');}return f},!0)};c.hooks={};c.hook_proc={none:{init:void 0,step:function(){}},pass:{init:function(a){return a[0]},step:function(a,b){return b}},or:{init:!1,
step:function(a,b){return a||b}},and:{init:!0,step:function(a,b){return a&&b}},mult:{init:1,step:function(a,b){return a*b}},add:{init:0,step:function(a,b){return a+b}},append:{init:"",step:function(a,b){return a+b}},push:{init:[],step:function(a,b){a.push(b);return a}},concat:{init:[],step:function(a,b){return c.concat(a,b)}},insert:{init:{},step:function(a,b){a[b]=!0;return a}},extend:{init:{},step:function(a,b){return c.extend(a,b)}}};c.latch=function(a,b){if(2>arguments.length)throw c.exception("latch(internal)",
"missing arguments");"undefined"===typeof c.hooks[a]&&(c.hooks[a]=[]);var e=c.slice(arguments,2),f=c.cid();c.hooks[a].push({id:f,cb:b,args:e});return f};c.unlatch=function(a,b){if(2!==arguments.length)throw c.exception("unlatch(internal)","invalid number of arguments");if("undefined"===typeof c.hooks[a])throw c.exception("unlatch(internal)","no such hook");for(var e=-1,f=0;f<c.hooks[a].length;f++)if(c.hooks[a][f].id===b){e=f;break}if(-1===e)throw c.exception("unlatch(internal)","no such latched callback");
c.hooks[a]=c.hooks[a].splice(e,1)};c.hook=function(a,b){if(2>arguments.length)throw c.exception("hook(internal)","missing argument");if("undefined"===typeof c.hook_proc[b])throw c.exception("hook(internal)","no such result processing defined");var e=c.hook_proc[b].init,f=null;"function"===typeof e&&(f=c.slice(arguments,2),e=e.call(null,f));"undefined"!==typeof c.hooks[a]&&(null===f&&(f=c.slice(arguments,2)),c.foreach(c.hooks[a],function(g){g=g.cb.apply({args:g.args,result:e,hooks:c.hooks[a].length,
_cs:c,$cs:d},f);e=c.hook_proc[b].step.call(null,e,g)}));return e};c.clazz_or_trait=function(a,b){var e=function(){var a=arguments.callee,b=arguments;if(!(this instanceof a))return new a;(function(a,b,e,f){var d=c.annotation(b,"extend");null!==d&&arguments.callee(a,d,e,!1);d=c.annotation(b,"mixin");if(null!==d)for(var g=0;g<d.length;g++)arguments.callee(a,d[g],e,!0);d=c.annotation(b,"dynamics");if(null!==d)for(var h in d)c.isown(d,h)&&("null"!==c.istypeof(d[h])&&"function"===c.istypeof(d[h].clone)?
a[h]=d[h].clone():a[h]=c.clone(d[h]));f&&(h=c.annotation(b,"cons"),null!==h&&("clazz"===c.istypeof(b)?h.apply(a,e):h.call(a)))})(this,a,b,!0)},f=function(a){return!a.match("^(?:base|__ComponentJS_[A-Za-z]+__)$")};if(c.isdefined(a.extend)){c.extend(e,a.extend,f);var g=function(){this.constructor=e};g.prototype=a.extend.prototype;e.prototype=new g;c.annotation(e,"extend",a.extend)}if(c.isdefined(a.mixin)){for(g=0;g<a.mixin.length;g++)c.extend(e,a.mixin[g],f),c.mixin(e.prototype,a.mixin[g].prototype,
f);c.annotation(e,"mixin",a.mixin)}f=d.nop;c.isdefined(a.cons)?f=a.cons:c.isdefined(a.extend)&&(f=function(){this.base()});c.annotation(e,"cons",f);c.annotation(f,"name","cons");c.isdefined(a.extend)&&c.annotation(f,"base",c.annotation(a.extend,"cons"));c.isdefined(a.setup)&&c.annotation(e,"setup",a.setup);c.isdefined(a.statics)&&c.extend(e,a.statics);c.isdefined(a.protos)&&c.mixin(e.prototype,a.protos);c.isdefined(a.dynamics)&&c.annotation(e,"dynamics",a.dynamics);var h=function(a,b){for(var e=c.annotation(a,
b);null===e&&!0===c.annotation(a.caller,"clone");)e=c.annotation(a.caller,b),a=a.caller;return e};e.prototype.base=function(){var a=h(arguments.callee.caller,"name"),b=h(arguments.callee.caller,"base"),e=c.annotation(this.constructor,"extend");if("function"===c.istypeof(b))return b.apply(this,arguments);if("string"===c.istypeof(a)&&"clazz"===c.istypeof(e)&&"function"===c.istypeof(e[a]))return e[a].apply(this,arguments);if("string"===c.istypeof(a)&&"clazz"===c.istypeof(e)&&"object"===c.istypeof(e.prototype)&&
"function"===c.istypeof(e.prototype[a]))return e.prototype[a].apply(this,arguments);throw c.exception("base",'no base method found for method "'+a+'" in inheritance/mixin chain');};b&&function(a,b){if("array"===c.istypeof(c.annotation(b,"mixin")))for(var e=c.annotation(b,"mixin"),f=0;f<e.length;f++)arguments.callee(a,e[f]);"function"===c.istypeof(c.annotation(b,"setup"))&&c.annotation(b,"setup").call(a)}(e,e);"string"===typeof a.name&&d.ns(a.name,e);return e};d.clazz=function(){var a=d.params("clazz",
arguments,{name:{def:void 0,valid:"string"},extend:{def:void 0,valid:"clazz"},mixin:{def:void 0,valid:"[trait*]"},cons:{def:void 0,valid:"function"},dynamics:{def:void 0,valid:"object"},protos:{def:void 0,valid:"object"},statics:{def:void 0,valid:"object"}}),a=c.clazz_or_trait(a,!0);c.annotation(a,"type","clazz");return a};d.trait=function(){var a=d.params("trait",arguments,{name:{def:void 0,valid:"string"},mixin:{def:void 0,valid:"[trait*]"},cons:{def:void 0,valid:"function"},setup:{def:void 0,valid:"function"},
dynamics:{def:void 0,valid:"object"},protos:{def:void 0,valid:"object"},statics:{def:void 0,valid:"object"}}),a=c.clazz_or_trait(a,!1);c.annotation(a,"type","trait");return a};d.pattern.id=d.trait({dynamics:{id:d.attribute("id",null)}});d.pattern.name=d.trait({dynamics:{name:d.attribute("name","")}});d.pattern.tree=d.trait({mixin:[d.pattern.name],dynamics:{parent:d.attribute("parent",null),children:d.attribute("children",[])},protos:{path:function(a){var b,c;if("undefined"===typeof a){b=[];for(c=
this;null!==c;c=c.parent())b.push(c)}else if(b="",null===this.parent())b=a;else for(c=this;null!==c.parent();c=c.parent())b=a+c.name()+b;return b},_attach:function(a){null!==this.parent()&&this.detach();var b=a.children();b.push(this);a.children(b);this.parent(a)},_detach:function(){if(null!==this.parent()){var a=this;this.parent().children(c.filter(this.parent().children(),function(b){return b!==a}));this.parent(null)}},walk_up:function(a,b){var c,f;c=0;for(f=this;null!==f;f=f.parent(),c++)b=a(c,
f,b);return b},walk_down:function(a,b){var c=function(b,d,h){"function"===typeof a&&(h=a(b,d,h,!1));for(var k=d.children(),l=0;l<k.length;l++)h=c(b+1,k[l],h);"function"===typeof a&&(h=a(b,d,h,!0));return h};return b=c(0,this,b)},_tree_dump:function(a){return this.walk_down(function(b,c,f,d){if(!d){for(d=0;d<b;d++)f+="    ";f+='"'+c.name()+'"';"function"===typeof a&&(f+=": "+a(c));f+="\n"}return f},"")}}});d.pattern.config=d.trait({dynamics:{__config:{}},protos:{cfg:function(a,b){var e;if(0===arguments.length){e=
[];for(var d in this.__config)c.isown(this.__config,d)&&e.push(d)}else if(1===arguments.length&&"string"===typeof a)e=this.__config[a];else if(2===arguments.length&&null!==b)e=this.__config[a],this.__config[a]=b;else if(2===arguments.length)e=this.__config[a],delete this.__config[a];else throw c.exception("cfg","invalid arguments");return e}}});d.pattern.spool=d.trait({dynamics:{__spool:{}},protos:{spool:function(){var a=d.params("spool",arguments,{name:{pos:0,req:!0},ctx:{pos:1,def:this},func:{pos:2,
req:!0},args:{pos:"...",def:[]}});if(!c.istypeof(a.func).match(/^(string|function)$/))throw c.exception("cleaner","invalid function (either function object or method name required)");if("string"===c.istypeof(a.func)){if("function"!==c.istypeof(a.ctx[a.func]))throw c.exception("cleaner",'invalid method name: "'+a.func+'"');a.func=a.ctx[a.func]}c.isdefined(this.__spool[a.name])||(this.__spool[a.name]=[]);this.__spool[a.name].push(a)},spooled:function(){var a=d.params("spooled",arguments,{name:{pos:0,
req:!0}});return c.isdefined(this.__spool[a.name])&&0<this.__spool[a.name].length},unspool:function(){var a=d.params("unspool",arguments,{name:{pos:0,req:!0}}),b=this.__spool[a.name];if(!c.isdefined(b))throw c.exception("unspool",'no such spool: "'+a.name+'"');for(var e=b.length-1;0<=e;e--)b[e].func.apply(b[e].ctx,b[e].args);delete this.__spool[a.name]}}});c.spool_spec_parse=function(a,b){var c={};c.comp=a;c.name=b;var f=c.name.match(/^([^:]+):(.+)$/);null!==f&&(c.comp=d(a,f[1]),c.name=f[2]);return c};
d.pattern.property=d.trait({mixin:[d.pattern.tree,d.pattern.config],protos:{property:function(){var a=d.params("property",arguments,{name:{pos:0,req:!0},value:{pos:1,def:void 0},bubbling:{def:!0},targeting:{def:!0},returnowner:{def:!1}});if(!a.targeting&&!a.bubbling)throw c.exception("property","disabling both targeting and bubbling makes no sense");var b;b=void 0;for(var e,f=[],g=this;null!==g;f.unshift(g.name()),g=g.parent())if(0!==f.length||a.targeting){if(0<f.length){for(var h=f.length-1;0<=h&&
!(e=f.slice(0,h+1).join("/"),e=g.cfg("ComponentJS:property:"+a.name+"@"+e),"undefined"!==typeof e);h--);if("undefined"!==typeof e){b=a.returnowner?g:e;break}}e=g.cfg("ComponentJS:property:"+a.name);if("undefined"!==typeof e){b=a.returnowner?g:e;break}if(!a.bubbling)break}"undefined"!==typeof a.value&&this.cfg("ComponentJS:property:"+a.name,a.value);return b}}});d.pattern.spec=d.trait({mixin:[d.pattern.name],dynamics:{__spec:{}},protos:{spec:function(){var a=this.__spec;if(0===arguments.length)return a;
if(1===arguments.length&&"string"===typeof arguments[0])return a[arguments[0]];for(var b=0;b<arguments.length;b++)if("string"===typeof arguments[b])a[arguments[b]]=arguments[b+1],b++;else if("object"===typeof arguments[b])for(var e in arguments[b])c.isown(arguments[b],e)&&(a[e]=arguments[b][e])},matches:function(a,b){if("string"===typeof a){if(this.name()!==a)return!1}else if("object"===typeof a&&a instanceof RegExp){if(!this.name().match(a))return!1}else throw c.exception("matches","invalid name pattern");
var e=this.__spec,d;for(d in b)if(c.isown(b,d)){if(!c.isdefined(e[d]))return!1;var g=b[d];switch(typeof e[d]){case "number":case "boolean":if(e[d]!==g)return!1;break;case "string":if(!("string"===typeof g&&e[d]===g||"object"===typeof g&&g instanceof RegExp&&!e[d].match(g)))return!1}}return!0}}});d.pattern.observable=d.trait({dynamics:{__listener:{}},protos:{listen:function(){var a=d.params("listen",arguments,{name:{pos:0,req:!0},ctx:{pos:1,def:this},func:{pos:2,req:!0},args:{pos:"...",def:[]},spec:{def:null}}),
b=c.cid();this.__listener[b]=a;return b},listening:function(){var a=d.params("listening",arguments,{id:{pos:0,req:!0}});return"undefined"!==typeof this.__listener[a.id]},unlisten:function(){var a=d.params("unlisten",arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__listener[a.id])throw c.exception("unlisten","listener not found");var b=this.__listener[a.id];delete this.__listener[a.id];return b},notify:function(){var a=d.params("notify",arguments,{name:{pos:0,req:!0},args:{pos:"...",def:[]},
matches:{def:function(a,b){return a.name===b.name}}}),b;for(b in this.__listener)if(c.isown(this.__listener,b)){var e=this.__listener[b];if(a.matches(a,e)){var f=c.concat(e.args,a.args);e.func.apply(e.ctx,f)}}}}});d.pattern.event=d.clazz({mixin:[d.pattern.spec],dynamics:{target:d.attribute("target",null),propagation:d.attribute("propagation",!0),processing:d.attribute("processing",!0),dispatched:d.attribute("dispatched",!1),decline:d.attribute("decline",!1),state:d.attribute("state","targeting"),
result:d.attribute("result",void 0),async:d.attribute("async",!1)}});d.event=function(){var a=d.params("event",arguments,{name:{pos:0,req:!0},spec:{def:{}},target:{pos:1,req:!0},propagation:{pos:2,def:!0},processing:{pos:3,def:!0},dispatched:{pos:4,def:!1},decline:{pos:5,def:!1},state:{pos:6,def:"targeting"},result:{pos:7,def:void 0},async:{pos:8,def:!1}}),b=new d.pattern.event;b.name(a.name);b.target(a.target);b.propagation(a.propagation);b.processing(a.processing);b.dispatched(a.dispatched);b.decline(a.decline);
b.state(a.state);b.result(a.result);b.spec(a.spec);b.async(a.async);return b};d.pattern.eventing=d.trait({dynamics:{__subscription:{}},protos:{subscribe:function(){var a=d.params("subscribe",arguments,{name:{pos:0,req:!0},spec:{def:{}},ctx:{def:this},func:{pos:1,req:!0},args:{pos:"...",def:[]},capturing:{def:!1},spreading:{def:!1},bubbling:{def:!0},noevent:{def:!1},exclusive:{def:!1},spool:{def:null}}),b=this._subscriptions(a.name,a.spec);if(1===b.length&&b[0].exclusive)throw c.exception("subscribe",
"existing exclusive subscription prevents additional one");if(a.exclusive&&0<b.length)throw c.exception("subscribe","non-exclusive subscription(s) prevent exclusive one");b=c.cid();this.__subscription[b]=a;null!==a.spool&&(a=c.spool_spec_parse(this,a.spool),a.comp.spool(a.name,this,"unsubscribe",b));return b},unsubscribe:function(){var a=d.params("unsubscribe",arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__subscription[a.id])throw c.exception("unsubscribe","subscription not found");
delete this.__subscription[a.id]},subscription:function(){var a=d.params("subscription",arguments,{id:{pos:0,req:!0}});return"undefined"!==typeof this.__subscription[a.id]},_subscriptions:function(){var a=d.params("subscriptions",arguments,{name:{pos:0,req:!0},spec:{pos:1,def:{}}}),a=d.event({name:a.name,spec:a.spec,target:d.nop}),b=[],e;for(e in this.__subscription)if(c.isown(this.__subscription,e)){var f=this.__subscription[e];a.matches(f.name,f.spec)&&b.push(f)}return b},publish:function(){var a,
b=this,e=d.params("publish",arguments,{name:{pos:0,req:!0},spec:{def:{}},async:{def:!1},capturing:{def:!0},spreading:{def:!0},bubbling:{def:!0},completed:{def:d.nop},resultinit:{def:void 0},resultstep:{def:function(a,b){return b}},directresult:{def:!1},noresult:{def:!1},firstonly:{def:!1},silent:{def:!1},args:{pos:"...",def:[]}}),f=!1;if(!e.capturing&&!e.spreading&&!e.bubbling){var g=!1,h;for(h in this.__subscription)if(c.isown(this.__subscription,h)){g=!0;break}if(!g){if(e.noresult)return;if(e.directresult)return e.resultinit;
f=!0}}var k=d.event({name:e.name,spec:e.spec,async:e.async,result:e.resultinit,target:b,propagation:!0,processing:!0,dispatched:!1});if(f)return k;e.silent||d.debug(1,"event: "+k.target().path("/")+": publish: name="+k.name()+" async="+k.async()+" capturing="+e.capturing+" spreading="+e.spreading+" bubbling="+e.bubbling+" directresult="+e.directresult+" noresult="+e.noresult+" firstonly="+e.firstonly);var l=function(a,b,e,f){for(var g in b.__subscription)if(c.isown(b.__subscription,g)){var h=b.__subscription[g];
if(("capturing"===f&&h.capturing||"targeting"===f||"spreading"===f&&h.spreading||"bubbling"===f&&h.bubbling)&&a.matches(h.name,h.spec)){e.silent||d.debug(1,"event: "+b.path("/")+": dispatch on "+f);a.state(f);a.decline(!1);var k=c.concat(h.noevent?[]:[a],h.args,e.args),k=h.func.apply(h.ctx,k);h.noevent&&c.isdefined(k)&&a.result(e.resultstep(a.result(),k));a.decline()||(a.dispatched(!0),e.firstonly&&a.propagation(!1))}}},m=function(b,c,e){var d;if(e.capturing||e.bubbling)d=c.path();if(e.capturing)for(a=
d.length-1;1<=a&&!(l(b,d[a],e,"capturing"),!b.propagation());a--);b.propagation()&&l(b,c,e,"targeting");if(e.spreading&&b.propagation()){var f=function(a,c){var d=!0;c||(l(b,a,e,"spreading"),b.propagation()||(b.propagation(!0),d=!1));if(d)for(var d=a.children(),g=0;g<d.length;g++)f(d[g],!1)};f(c,!0)}if(e.bubbling&&b.propagation())for(a=1;a<d.length&&!(l(b,d[a],e,"bubbling"),!b.propagation());a++);e.completed.call(c,b)};k.async()?setTimeout(c.hook("ComponentJS:settimeout:func","pass",function(){m(k,
b,e)}),0):m(k,b,e);if(!e.noresult)return e.directresult?k.result():k}}});d.pattern.command=d.clazz({mixin:[d.pattern.observable],dynamics:{ctx:d.attribute("ctx",null),func:d.attribute("func",d.nop),args:d.attribute("args",[]),async:d.attribute("async",!1),enabled:d.attribute({name:"enabled",def:!0,validate:function(a){return"boolean"===typeof a}})},protos:{execute:function(a,b){if(this.enabled()){var e=[];this.async()&&e.push(function(a){"function"===typeof b&&b(a)});e=c.concat(e,this.args(),a);return this.func().apply(this.ctx(),
e)}}}});d.command=function(){var a=d.params("command",arguments,{ctx:{def:null},func:{pos:0,req:!0},args:{pos:"...",def:[]},async:{def:!1},enabled:{def:!0},wrap:{def:!1}}),b=new d.pattern.command;b.ctx(a.ctx);b.func(a.func);b.args(a.args);b.async(a.async);b.enabled(a.enabled);var e=b;a.wrap&&(e=function(){var a=c.concat(arguments);return arguments.callee.command.execute.call(arguments.callee.command,a)},e.command=b);return e};c.states=[{enter:null,leave:null,state:"dead",color:"#000000"}];c.states_clear=
function(){c.states=c.slice(c.states,0,1)};c.states_add=function(a,b,e,d,g){a={enter:b,leave:e,state:a,color:d};for(b=1;b<c.states.length&&!(null!==g&&c.states[b].state===g);)b++;c.states.splice(b,0,a)};c.state_name2idx=function(a){var b=-1,e;for(e=0;e<c.states.length;e++)if(c.states[e].state===a){b=e;break}return b};c.state_method_call=function(a,b,e){var d=!0,g=b.obj();null!==g&&"function"===typeof g[e]&&(a={type:a,comp:b,method:e,ctx:g,func:g[e]},c.hook("ComponentJS:state-method-call","none",a),
d=a.func.call(a.ctx));return d};c.state_requests={};c.state_progression=function(){setTimeout(c.hook("ComponentJS:settimeout:func","pass",function(){var a=[],b;for(b in c.state_requests)c.isown(c.state_requests,b)&&c.state_progression_single(c.state_requests[b])&&a.push(b);c.foreach(a,function(a){delete c.state_requests[a]});c.hook("ComponentJS:state-change","none")}),0)};c.state_progression_single=function(a){var b=!1;c.state_progression_run(a.comp,a.state);c.states[a.comp.__state].state===a.state&&
("function"===typeof a.callback&&a.callback.call(a.comp,a.state),b=!0);return b};c.state_progression_run=function(a,b,e){var f,g;"undefined"===typeof e&&(e="upward-and-downward");var h=c.state_name2idx(b);if(-1===h)throw c.exception("state",'invalid argument "'+b+'"');if(a.__state<h)for(;a.__state<h;){g=c.states[a.__state+1].state;f=c.states[a.__state+1].enter;if(null!==a.parent()&&0>a.parent().state_compare(g)&&(c.state_progression_run(a.parent(),g,"upward"),0>a.parent().state_compare(g))){d.debug(1,
"state: "+a.path("/")+": transition (increase) REJECTED BY PARENT COMPONENT ("+a.parent().path("/")+"): @"+c.states[a.__state].state+" --("+f+")--\x3e @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");break}if(c.isdefined(a.__state_guards[f])){d.debug(1,"state: "+a.path("/")+": transition (increase) REJECTED BY ENTER GUARD: @"+c.states[a.__state].state+" --("+f+")--\x3e @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");break}a.__state++;d.debug(1,"state: "+
a.path("/")+": transition (increase): @"+c.states[a.__state-1].state+" --("+f+")--\x3e @"+c.states[a.__state].state);c.hook("ComponentJS:state-invalidate","none","states");c.hook("ComponentJS:state-change","none");b="ComponentJS:state:"+c.states[a.__state].state+":enter";a.spooled(b)&&a.unspool(b);if(!1===c.state_method_call("enter",a,f)){d.debug(1,"state: "+a.path("/")+": transition (increase) REJECTED BY ENTER METHOD: @"+c.states[a.__state-1].state+" --("+f+")--\x3e @"+c.states[a.__state].state+
": SUSPENDING CURRENT TRANSITION RUN");a.__state--;break}a.publish({name:"ComponentJS:state:"+c.states[a.__state].state,noresult:!0,capturing:!1,spreading:!1,bubbling:!1,async:!0,silent:!0});if("upward-and-downward"===e||"downward"===e){f=a.children();for(b=0;b<f.length;b++)if(0>f[b].state_compare(g)&&(f[b].state_auto_increase()||!0===f[b].property("ComponentJS:state-auto-increase")))c.state_progression_run(f[b],g,"downward"),0>f[b].state_compare(g)&&(c.state_requests[f[b].id()]={comp:f[b],state:g},
c.hook("ComponentJS:state-invalidate","none","requests"),c.hook("ComponentJS:state-change","none"))}}else if(a.__state>h)for(;a.__state>h;){g=c.states[a.__state].leave;var k=c.states[a.__state-1].state;f=a.children();for(b=0;b<f.length;b++)if(0<f[b].state_compare(k)&&(c.state_progression_run(f[b],k,"downward"),0<f[b].state_compare(k))){d.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY CHILD COMPONENT ("+f[b].path("/")+"): @"+c.states[a.__state-1].state+" <--("+g+")-- @"+c.states[a.__state].state+
": SUSPENDING CURRENT TRANSITION RUN");return}if(c.isdefined(a.__state_guards[g])){d.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY LEAVE GUARD: @"+c.states[a.__state-1].state+" <--("+g+")-- @"+c.states[a.__state].state+": SUSPENDING CURRENT TRANSITION RUN");break}a.__state--;d.debug(1,"state: "+a.path("/")+": transition (decrease): @"+c.states[a.__state].state+" <--("+g+")-- @"+c.states[a.__state+1].state);c.hook("ComponentJS:state-invalidate","none","states");c.hook("ComponentJS:state-change",
"none");b="ComponentJS:state:"+c.states[a.__state+1].state+":leave";a.spooled(b)&&a.unspool(b);if(!1===c.state_method_call("leave",a,g)){d.debug(1,"state: "+a.path("/")+": transition (decrease) REJECTED BY LEAVE METHOD: @"+c.states[a.__state].state+" <--("+g+")-- @"+c.states[a.__state+1].state+": SUSPENDING CURRENT TRANSITION RUN");a.__state++;break}a.publish({name:"ComponentJS:state:"+c.states[a.__state].state,noresult:!0,capturing:!1,spreading:!1,bubbling:!1,async:!0,silent:!0});if("upward-and-downward"===
e||"upward"===e)if(null!==a.parent()&&0<a.parent().state_compare(k)&&(a.parent().state_auto_decrease()||!0===a.parent().property("ComponentJS:state-auto-decrease")))c.state_progression_run(a.parent(),k,"upward"),0<a.parent().state_compare(k)&&(c.state_requests[a.parent().id()]={comp:a.parent(),state:k},c.hook("ComponentJS:state-invalidate","none","requests"),c.hook("ComponentJS:state-change","none"))}};d.pattern.state=d.trait({mixin:[d.pattern.tree],dynamics:{__state:0,__state_guards:{},state_auto_increase:d.attribute("state_auto_increase",
!1),state_auto_decrease:d.attribute("state_auto_decrease",!1)},protos:{state:function(){var a=c.states[this.__state].state;if(0===arguments.length)return a;var b=d.params("state",arguments,{state:{pos:0,req:!0,valid:function(a){return-1!==c.state_name2idx(a)}},callback:{pos:1,def:void 0},sync:{def:!1}});if(c.states[this.__state].state!==b.state){var e=!0,f={comp:this,state:b.state,callback:b.callback};b.sync&&c.state_progression_single(f)&&(e=!1);e&&(c.state_requests[this.id()]=f,c.hook("ComponentJS:state-invalidate",
"none","requests"),c.state_progression())}else"function"===typeof b.callback&&b.callback.call(this,b.state);return a},state_compare:function(){var a=d.params("state",arguments,{state:{pos:0,req:!0,valid:function(a){return-1!==c.state_name2idx(a)}}}),a=c.state_name2idx(a.state);return this.__state-a},guard:function(){var a=d.params("guard",arguments,{method:{pos:0,valid:"string",req:!0},level:{pos:1,valid:"number",req:!0}}),b=!1,e;for(e=0;e<c.states.length;e++)if(c.states[e].enter===a.method||c.states[e].leave===
a.method){b=!0;break}if(!b)throw c.exception("guard",'no such declared enter/leave method: "'+a.method+'"');c.isdefined(this.__state_guards[a.method])||(this.__state_guards[a.method]=0);b=!1;if(0<a.level)this.__state_guards[a.method]+=a.level;else if(0>a.level){if(this.__state_guards[a.method]<-a.level)throw c.exception("guard","guard level decrease request too large");this.__state_guards[a.method]+=a.level;0===this.__state_guards[a.method]&&(b=!0)}else this.__state_guards[a.method]=0,b=!0;b&&(delete this.__state_guards[a.method],
c.state_progression())}}});d.pattern.service=d.trait({mixin:[d.pattern.eventing],protos:{register:function(){var a=d.params("register",arguments,{name:{pos:0,req:!0},ctx:{def:this},func:{pos:1,req:!0},args:{pos:"...",def:[]},async:{def:!1},spool:{def:null},capturing:{def:!1},spreading:{def:!1},bubbling:{def:!0}}),b=d.command({ctx:a.ctx,func:a.func,args:a.args,async:a.async,wrap:!0});b.command.listen({name:"attribute:set:enabled",args:[this,a.name],func:function(a,b,c,d){a.publish({name:"ComponentJS:service:"+
b+":callable",args:[c,d],capturing:!1,spreading:!1,bubbling:!1,async:!0,noresult:!0})}});b=this.subscribe({name:"ComponentJS:service:"+a.name,ctx:a.ctx,func:b,noevent:!0,capturing:a.capturing,spreading:a.spreading,bubbling:a.bubbling,exclusive:!0});null!==a.spool&&(a=c.spool_spec_parse(this,a.spool),a.comp.spool(a.name,this,"unregister",b));return b},registration:function(){var a=d.params("registration",arguments,{id:{pos:0,req:!0}});return this.subscription(a.id)},unregister:function(){var a=d.params("unregister",
arguments,{id:{pos:0,req:!0}});this.unsubscribe(a.id)},callable:function(){var a=d.params("callable",arguments,{name:{pos:0,req:!0},value:{pos:1,def:void 0}}),b=this._subscriptions(a.name);return 1!==b.length?void 0:b[0].func().command.enabled(a.value)},call:function(){var a=d.params("call",arguments,{name:{pos:0,req:!0},args:{pos:"...",def:[]},capturing:{def:!1},spreading:{def:!1},bubbling:{def:!0}}),b=this.publish({name:"ComponentJS:service:"+a.name,args:a.args,capturing:a.capturing,spreading:a.spreading,
bubbling:a.bubbling,firstonly:!0,async:!1});if(!b.dispatched())throw c.exception("call",'no such registered service found: "'+a.name+'"');return b.result()}}});d.pattern.shadow=d.trait({dynamics:{__obj:null},protos:{obj:function(a){if("undefined"===typeof a)return this.__obj;if("object"===typeof a)null!==a?(c.annotation(a,"comp",this),this.__obj=a):(null!==this.__obj&&c.annotation(this.__obj,"comp",null),this.__obj=null);else throw c.exception("obj","invalid argument");return this},access:function(a,
b){if("undefined"===typeof a)throw c.exception("access","no attribute name given");var e=this.obj();if(null===e)throw c.exception("access","still no object attached");if("undefined"===typeof e[a])throw c.exception("access",'invalid attribute "'+a+'"');var d=e[a];"undefined"!==typeof b&&(e[a]=b);return d},invoke:function(a){if("undefined"===typeof a)throw c.exception("invoke","no method name given");var b=this.obj();if(null===b)throw c.exception("invoke","still no object attached");if("undefined"===
typeof b[a])throw c.exception("invoke",'invalid method "'+a+'"');if("function"!==c.istypeof(b[a]))throw c.exception("invoke",'anything named "'+a+'" existing, but not a function');var e=c.slice(arguments,1);return b[a].apply(b,e)}}});d.pattern.socket=d.trait({mixin:[d.pattern.tree,d.pattern.property],dynamics:{__sockets:{},__plugs:{}},protos:{socket:function(){var a=d.params("socket",arguments,{name:{def:"default"},scope:{def:null},ctx:{pos:0,req:!0},plug:{pos:1,req:!0},unplug:{pos:2,req:!0},spool:{def:null}});
if("string"===c.istypeof(a.plug)&&"function"!==c.istypeof(a.ctx[a.plug]))throw c.exception("socket",'no plug method named "'+a.plug+'" found on context object');if("string"!==c.istypeof(a.plug)&&"function"!==c.istypeof(a.plug))throw c.exception("socket","plug operation neither method name nor function");if("string"===c.istypeof(a.unplug)&&"function"!==c.istypeof(a.ctx[a.unplug]))throw c.exception("socket",'no unplug method named "'+a.unplug+'" found on context object');if("string"!==c.istypeof(a.unplug)&&
"function"!==c.istypeof(a.unplug))throw c.exception("socket","unplug operation neither method name nor function");var b="ComponentJS:socket:"+a.name;null!==a.scope&&(b+="@"+a.scope);d(this).property(b,a);var e=c.cid();this.__sockets[e]=b;null!==a.spool&&(a=c.spool_spec_parse(this,a.spool),a.comp.spool(a.name,this,"unsocket",e));return e},unsocket:function(){var a=d.params("unsocket",arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__sockets[a.id])throw c.exception("unsocket","socket not found");
var b=this.__sockets[a.id];d(this).property(b,null);delete this.__sockets[a.id]},link:function(){var a=d.params("link",arguments,{name:{def:"default"},scope:{def:null},target:{pos:0,req:!0},socket:{pos:1,req:!0},spool:{def:null}});return this.socket({name:a.name,scope:a.scope,spool:a.spool,ctx:{},plug:function(b){var e=c.annotation(b,"link");if(null!==e)throw c.exception("link:plug: cannot plug, you have to unplug first");e=d(a.target).plug({name:a.socket,object:b});c.annotation(b,"link",e)},unplug:function(b){var e=
c.annotation(b,"link");if(null===e)throw c.exception("link:unplug: cannot unplug, you have to plug first");d(a.target).unplug(e);c.annotation(b,"link",null)}})},unlink:function(){var a=d.params("unlink",arguments,{id:{pos:0,req:!0}});return this.unsocket(a.id)},plug:function(){var a=d.params("plug",arguments,{name:{def:"default"},object:{pos:0,req:!0},spool:{def:null}}),b=c.cid();this.__plugs[b]=a;c.plugger("plug",this,a.name,a.object);null!==a.spool&&(a=c.spool_spec_parse(this,a.spool),a.comp.spool(a.name,
this,"unplug",b));return b},unplug:function(){var a=d.params("unplug",arguments,{id:{pos:0,req:!0}});if("undefined"===typeof this.__plugs[a.id])throw c.exception("unplug","plugging not found");c.plugger("unplug",this,this.__plugs[a.id].name,this.__plugs[a.id].object);delete this.__plugs[a.id]}}});c.plugger=function(a,b,e,f){var g="ComponentJS:socket:"+e,h=b.property({name:g,targeting:!1});if(!c.isdefined(h))throw c.exception(a,"no socket found on parent component(s)");g=b.property({name:g,targeting:!1,
returnowner:!0});d.debug(1,"socket: "+g.path("/")+": "+e+" <--("+a+")-- "+b.path("/"));if("string"===c.istypeof(h[a]))h.ctx[h[a]].call(h.ctx,f);else if("function"===c.istypeof(h[a]))h[a].call(h.ctx,f);else throw c.exception(a,'failed to perform "'+a+'" operation');};d.pattern.hook=d.trait({mixin:[d.pattern.eventing],protos:{latch:function(){var a=d.params("latch",arguments,{name:{pos:0,req:!0},ctx:{def:this},func:{pos:1,req:!0},args:{pos:"...",def:[]},spool:{def:null}}),b=this.subscribe({name:"ComponentJS:hook:"+
a.name,ctx:a.ctx,func:a.func,args:a.args,noevent:!0});null!==a.spool&&(a=c.spool_spec_parse(this,a.spool),a.comp.spool(a.name,this,"unlatch",b));return b},unlatch:function(){var a=d.params("unlatch",arguments,{id:{pos:0,req:!0}});this.unsubscribe(a.id)},hook:function(){var a=d.params("hook",arguments,{name:{pos:0,req:!0},proc:{pos:1,def:"none",valid:function(a){return c.isdefined(c.hook_proc[a])}},args:{pos:"...",def:[]}});return this.publish({name:"ComponentJS:hook:"+a.name,args:a.args,capturing:!1,
spreading:!1,bubbling:!1,async:!1,resultinit:c.hook_proc[a.proc].init,resultstep:c.hook_proc[a.proc].step,directresult:!0})}}});d.mark=function(a,b){var e=c.annotation(a,"marker");null===e&&(e={});e[b]=!0;c.annotation(a,"marker",e)};d.marked=function(a,b){var e=c.annotation(a,"marker");null===e&&(e={});return!0===e[b]};d.pattern.marker=d.trait({protos:{mark:function(a){d.mark(this.obj(),a)},marked:function(a){return d.marked(this.obj(),a)}}});d.marker={service:d.trait({cons:function(){d.mark(this,
"service")}}),controller:d.trait({cons:function(){d.mark(this,"controller")}}),model:d.trait({cons:function(){d.mark(this,"model")}}),view:d.trait({cons:function(){d.mark(this,"view")}})};c.store_load=function(a){if(null===a.__store&&(c.hook("ComponentJS:store-load","none",a),null===a.__store||"object"!==typeof a.__store))a.__store={}};c.store_save=function(a){null!==a.__store&&c.hook("ComponentJS:store-save","none",a)};d.pattern.store=d.trait({dynamics:{__store:null},protos:{store:function(){var a,
b;if(0===arguments.length){c.store_load(this);b=[];for(a in this.__store)b.push(a);return b}if(1===arguments.length&&null===arguments[0])return this.__store={},c.store_save(this),null;if(1===arguments.length&&"string"===typeof arguments[0])return c.store_load(this),a=arguments[0],"undefined"===typeof this.__store[a]?null:this.__store[a];if(2===arguments.length&&null===arguments[1])return c.store_load(this),a=arguments[0],delete this.__store[a],c.store_save(this),null;if(2===arguments.length)return c.store_load(this),
a=arguments[0],b=arguments[1],this.__store[a]=b,c.store_save(this),b;throw c.exception("store","invalid argument(s)");}}});d.pattern.model=d.trait({protos:{model:function(){var a=d.params("model",arguments,{model:{pos:0,def:null}}).model;null===a&&(a=void 0);var b;if(c.isdefined(a))for(b in a){"undefined"===typeof a[b].value&&(a[b].value="");"undefined"===typeof a[b].valid&&(a[b].valid="string");"undefined"===typeof a[b].autoreset&&(a[b].autoreset=!1);"undefined"===typeof a[b].store&&(a[b].store=
!1);for(var e in a[b])if("value"!==e&&"valid"!==e&&"autoreset"!==e&&"store"!==e)throw c.exception("model",'invalid specification key "'+e+'" in specification of model field "'+b+'"');if(!d.validate(a[b].value,a[b].valid))throw c.exception("model",'model field "'+b+'" has default value "'+a[b].value+'", which does not validate against validation "'+a[b].valid+'"');}var f=this.store("model");if(null!==f&&c.isdefined(a))for(b in a)a[b].store&&c.isdefined(f[b])&&(a[b].value=f[b]);e=this.property({name:"ComponentJS:model",
bubbling:!1});if(c.isdefined(a)){c.isdefined(e)?(f={},c.extend(f,e),c.extend(f,a),this.property("ComponentJS:model",f),a=f):this.property("ComponentJS:model",a);var f={},g=!1;for(b in a)a[b].store&&(f[b]=a[b].value,g=!0);g&&this.store("model",f)}return e},value:function(){for(var a=d.params("value",arguments,{name:{pos:0,req:!0},value:{pos:1,def:void 0},force:{pos:2,def:!1},returnowner:{def:!1}}),b=null,e=null,f=this;null!==f;){b=f.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("value",
'no model found containing value "'+a.name+'"');e=b.property("ComponentJS:model");if(c.isdefined(e[a.name]))break;f=b.parent()}if(null===f)throw c.exception("value",'no model found containing value "'+a.name+'"');var f=a.value,g,h=e[a.name].value;"undefined"===typeof f&&!0===b.property({name:"ComponentJS:model:subscribers:get",bubbling:!1})&&(g=b.publish({name:"ComponentJS:model:"+a.name+":get",args:[h],capturing:!1,spreading:!1,bubbling:!1,async:!1}),g.processing()&&(h=e[a.name].value,g=g.result(),
"undefined"!==typeof g&&(h=g)));if("undefined"!==typeof f&&(a.force||h!==f)){if(!d.validate(f,e[a.name].valid))throw c.exception("value",'invalid value "'+f+'" for model field "'+a.name+'"');var k=!0;!0===b.property({name:"ComponentJS:model:subscribers:set",bubbling:!1})&&(g=b.publish({name:"ComponentJS:model:"+a.name+":set",args:[f,h],capturing:!1,spreading:!1,bubbling:!1,async:!1}),g.processing()?(g=g.result(),"undefined"!==typeof g&&(f=g)):k=!1);k&&!e[a.name].autoreset&&(e[a.name].value=f,e[a.name].store&&
(k=b.store("model"),k[a.name]=e[a.name].value,b.store("model",k)),!0===b.property({name:"ComponentJS:model:subscribers:changed",bubbling:!1})&&b.publish({name:"ComponentJS:model:"+a.name+":changed",args:[f,h],noresult:!0,capturing:!1,spreading:!1,bubbling:!1,async:!0}))}return a.returnowner?b:h},touch:function(){var a=d.params("touch",arguments,{name:{pos:0,req:!0}});this.value({name:a.name,value:this.value(a.name),force:!0})},observe:function(){for(var a=d.params("observe",arguments,{name:{pos:0,
req:!0},func:{pos:1,req:!0},touch:{def:!1},operation:{def:"set"},spool:{def:null}}),b=null,e=null,f=this;null!==f;){b=f.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("observe",'no model found containing value "'+a.name+'"');e=b.property("ComponentJS:model");if(c.isdefined(e[a.name]))break;f=b.parent()}if(null===f)throw c.exception("observe",'no model found containing value "'+a.name+'"');e=b.subscribe({name:"ComponentJS:model:"+a.name+":"+a.operation,capturing:!1,
spreading:!1,bubbling:!1,func:a.func});b.property("ComponentJS:model:subscribers:"+a.operation,!0);null!==a.spool&&(b=c.spool_spec_parse(this,a.spool),b.comp.spool(b.name,this,"unobserve",e));a.touch&&this.touch(a.name);return e},unobserve:function(){for(var a=d.params("unobserve",arguments,{id:{pos:0,req:!0}}),b=null,e=this;null!==e;){b=e.property({name:"ComponentJS:model",returnowner:!0});if(!c.isdefined(b))throw c.exception("unobserve","no model subscription found");if(b.subscription(a.id))break;
e=b.parent()}if(null===e)throw c.exception("unobserve","no model subscription found");b.unsubscribe(a.id)}}});c.comp=null;c.none=null;c.root=null;c.comp_mixins=[d.pattern.id,d.pattern.name,d.pattern.tree,d.pattern.config,d.pattern.spool,d.pattern.state,d.pattern.service,d.pattern.eventing,d.pattern.property,d.pattern.shadow,d.pattern.socket,d.pattern.model,d.pattern.store,d.pattern.marker];c.comp_cons=function(a,b,e){c.annotation(this,"type","component");"string"!==c.istypeof(a)&&(a="<unknown>");
this.name(a);this.parent("object"===c.istypeof(b)?b:null);this.children("array"===c.istypeof(e)?e:[])};c.comp_protos={create:function(){return d.create.apply(this,c.concat([this],arguments))},destroy:function(){return d.destroy.apply(this,c.concat([this],arguments))},exists:function(){return"<none>"!==this.name()}};c.bootstrapped=!1;d.bootstrap=function(){if(c.bootstrapped)throw c.exception("bootstrap","library already bootstrapped");c.hook("ComponentJS:bootstrap:comp:mixin","none",c.comp_mixins);
c.hook("ComponentJS:bootstrap:comp:protos","none",c.comp_protos);c.comp=d.clazz({mixin:c.comp_mixins,cons:c.comp_cons,protos:c.comp_protos});c.root=new c.comp("<root>",null,[]);c.none=new c.comp("<none>",null,[]);c.foreach("call callable create destroy guard hook invoke latch link model observe plug property publish register registration socket spool spooled state state_compare store subscribe subscription touch unlatch unobserve unplug unregister unspool unsubscribe value".split(" "),function(a){c.none[a]=
function(){throw c.exception(a,'no such component (you are calling method "'+a+'" on component "<none>")');}});c.hook("ComponentJS:bootstrap","none");c.bootstrapped=!0};d.shutdown=function(){if(!c.bootstrapped)throw c.exception("shutdown","library still not bootstrapped");c.hook("ComponentJS:shutdown","none");c.none=null;c.root.destroy();c.root=null;c.comp=null;c.bootstrapped=!1};c.lookup=function(a,b){1===arguments.length&&("string"===c.istypeof(arguments[0])?(b=a,a=c.root):b="");if("string"!==typeof b)return c.none;
if("<root>"===b)return c.root;if("<none>"===b)return c.none;var e;if("/"===b.substr(0,1))e=c.root,b=b.substring(1);else{e=c.istypeof(a);var d=c.annotation(a,"comp");if("component"!==e&&null!==d)e=d;else{if("component"!==e)throw c.exception("lookup",'invalid base component (type is "'+e+'")');e=a}}if(""!==b)if(d=[],c.lookup_step(d,e,b.split("/"),0),0===d.length)e=c.none;else if(1===d.length)e=d[0];else{var g={},d=c.filter(d,function(a){a=a.id();var b="undefined"===typeof g[a];g[a]=!0;return b});if(1===
d.length)e=d[0];else{for(var h="",k=0;k<d.length;k++)h+=" "+d[k].path("/");throw c.exception("lookup",'ambiguous component path "'+b+'" at '+e.path("/")+": expected only 1 component, but found "+d.length+" components:"+h);}}return e};c.lookup_step=function(a,b,d,f){var g;if(f>=d.length)a.push(b);else if("."===d[f])c.lookup_step(a,b,d,f+1);else if(".."===d[f])null!==b.parent()&&c.lookup_step(a,b.parent(),d,f+1);else if("*"===d[f]){g=b.children();for(b=0;b<g.length;b++)c.lookup_step(a,g[b],d,f+1)}else if(""===
d[f]){g=b.walk_down(function(a,b,c,d){d||c.push(b);return c},[]);for(b=0;b<g.length;b++)c.lookup_step(a,g[b],d,f+1)}else{g=b.children();for(b=0;b<g.length;b++)if(g[b].name()===d[f]){c.lookup_step(a,g[b],d,f+1);break}}};d.create=function(){c.bootstrapped||(alert('WARNING: ComponentJS still not bootstrapped (please call "bootstrap" method before first "create" method call!)'),d.bootstrap());if(2>arguments.length)throw c.exception("create","invalid number of arguments");var a=0,b=null,e=null,f=[];if("string"===
c.istypeof(arguments[a])){if("/"!==arguments[a].substr(0,1))throw c.exception("create",'either base component has to be given or the tree specification has to start with the root component ("/")');b=c.root}else if(e=arguments[a++],"component"!==c.istypeof(e)&&(e=c.annotation(e,"comp"),null===e))throw c.exception("create","invalid base argument (not an object attached to a component)");for(var g=[],h=arguments[a++],k;""!==h;){k=h.match(/^\s*([^\/{},]+|[\/{},])/);if(null===k)break;g.push(k[1]);h=h.substr(k[1].length)}h=
function(a,b){for(var c="",d=0;d<b&&d<a.length;d++)c+=a[d];if(d<a.length){c=c+"<"+a[d++];for(c+=">";d<a.length;d++)c+=a[d]}return c};for(k=0;k<g.length;k++)if("/"===g[k]){if(null===b)throw c.exception("create","no parent component for step-down at "+h(g,k));e=b}else if("{"===g[k])f.push(e);else if(","===g[k]){if(0===f.length)throw c.exception("create","no open brace section for parallelism at "+h(g,k));e=f[f.length-1]}else if("}"===g[k]){if(0===f.length)throw c.exception("create","no more open brace section for closing at "+
h(g,k));e=f.pop();b=null}else{if(null===e)throw c.exception("create","no base component at "+h(g,k));b=c.create_single(e,g[k],arguments[a++])}if(0<f.length)throw c.exception("create","still open brace sections at end of tree specification");return b};c.create_single=function(a,b,e){if("string"!==typeof b)throw c.exception("create","invalid path argument (not a string)");var f=b.match(/^(.*?)\/?([^\/]+)$/);if(!f[0])throw c.exception("create",'invalid path "'+b+'"');var g=f[1],f=f[2];b=c.cid();f=f.replace(/\{id\}/g,
b);a=c.lookup(a,g);if(a===c.none)throw c.exception("create",'parent component path "'+g+'" not already existing (please create first)');g=c.lookup(a,f);if(g!==c.none)throw c.exception("create",'leaf component path "'+f+'" already existing (please destroy first)');var h=null;switch(c.istypeof(e)){case "clazz":case "trait":case "function":h=new e;break;case "object":h=e;break;case "null":break;default:throw c.exception("create","invalid class argument");}g=new c.comp(f);g.id(b);g._attach(a);g.obj(h);
d.debug(1,"component: "+g.path("/")+": created component ["+g.id()+"]");g.state({state:"created",sync:!0});c.hook("ComponentJS:state-invalidate","none","components");c.hook("ComponentJS:state-change","none");return g};d.destroy=function(){if(1!==arguments.length&&2!==arguments.length)throw c.exception("destroy","invalid number of arguments");var a=c.lookup.apply(this,arguments);if(a===c.none)throw c.exception("destroy","no such component found to destroy");if(a===c.root)throw c.exception("destroy",
"root component cannot be destroyed");a.state({state:"dead",sync:!0});a._detach();a.obj(null);d.debug(1,"component: "+a.path("/")+": destroyed component ["+a.id()+"]");c.hook("ComponentJS:state-invalidate","none","components");c.hook("ComponentJS:state-change","none")};d.transition=function(){if(1===arguments.length&&null===arguments[0])c.states_clear();else{var a=d.params("transition",arguments,{target:{pos:0,req:!0},enter:{pos:1,req:!0},leave:{pos:2,req:!0},color:{pos:3,def:"#000000"},source:{def:null}});
c.states_add(a.target,a.enter,a.leave,a.color,a.source)}};d.transition("created","create","destroy","#cc3333");d.transition("configured","setup","teardown","#eabc43");d.transition("prepared","prepare","cleanup","#f2ec00");d.transition("materialized","render","release","#6699cc");d.transition("visible","show","hide","#669933");"object"===typeof r&&"undefined"===typeof m.ComponentJS_export||"undefined"!==typeof m.ComponentJS_export&&"CommonJS"===m.ComponentJS_export?r.ComponentJS=d:"function"===typeof p&&
"object"===typeof p.amd&&"undefined"===typeof m.ComponentJS_export||"undefined"!==typeof m.ComponentJS_export&&"AMD"===m.ComponentJS_export?p("ComponentJS",function(){return d}):d.symbol("ComponentJS");c.plugins={};d.plugin=function(a,b){if(0===arguments.length){var e=[];for(a in c.plugins)c.isown(c.plugins,a)&&e.push(a);return e}if(1===arguments.length){if("string"!==typeof a)throw c.exception("plugin","invalid plugin name parameter");return"undefined"!==typeof c.plugins[a]}if(2===arguments.length){if("string"!==
typeof a)throw c.exception("plugin","invalid plugin name parameter");if("undefined"!==typeof c.plugins[a])throw c.exception("plugin",'plugin named "'+a+'" already registered');b.call(this,c,d,m);c.plugins[a]=!0}else throw c.exception("plugin","invalid number of parameters");}})("undefined"!==typeof window?window:"undefined"!==typeof global?global:"undefined"!==typeof this?this:{},"object"===typeof exports?exports:void 0,"function"===typeof define?define:void 0);
